
.data
ListboxClass   db  'listbox',0
EditClass      db  'edit',0
ButtClass      db  'button',0

szDummy        db  'A:\Dummy.dum',0
szSpacebar     db  'You can press the space bar to stop the search.',0
szNone         db  ' none This will  D E L E T E  the extension key!',0
szUFile        db  '_file',0
szBFile        db  ' file',0
szPercent1     db  ' %1',0
szPercent1M    db  ' vlc -vvv ',0
szZero         db  ',0',0
szExe          db  '.exe',0
szDll          db  '.dll',0
szIco          db  '.ico',0
szZip          db  '.zip',0
szFolderT      db  '.Folder',0
szRegIcon      db  '\DefaultIcon',0
szRegShell     db  '\shell',0
szRegOpen      db  '\open',0
szRegCmd       db  '\command',0
szRegOWL       db  '\OpenWithList',0
szRegSEC       db  '\shell\edit\command',0
szRegSOC       db  '\shell\open\command',0
szRegSPC       db  '\shell\print\command',0
szNoFileSel    db  'There was no file selection !',0
szNoZip        db  'The selection is not a ZIP file !',0
szZipError     db  'You first need to select a Pack/UnPack program from the option menu.',0
szRemError     db  'Your Removable is either write protected or went out to lunch!',0
szNoAssoc      db  'There was no association for the selected extension.',0
szAssoc        db  '*.exe *.dll *.com *.bat *.pif *.ico',0,'*.exe;*.dll;*.com;*.bat;*.pif;*.ico',0,
                   'All Files',0,'*.*',0,0
szExeOpen      db  '*.exe',0,'*.exe',0,
                   'All Files',0,'*.*',0,0

szTimePict     db  '  :  :  :   ',0
szLparen       db  '  (',0
szRparen       db  ')',0
szComma        db  ',',0
szFolderP      db  '\*',0
szCRLF         db  0dh,0ah,0

.data?
hCursor        dd  ?
hTemp01        dd  ?
hEdit01        dd  ?
hEdit02        dd  ?
hEdit03        dd  ?
hStatic01      dd  ?
hButtE         dd  ?
hButtI         dd  ?
hCombo         dd  ?
hList          dd  ?
hCenter        dd  ?
DelKey         dd  ?
hIcon1         dd  ?
hIcon2         dd  ?
hMemHeap       dd  ?
hHeapAlloc     dd  ?
SavIcon        dd  ?
SavIconID      dd  ?
fpMem          dd  ?
hpMem          dd  ?
BytesR         dd  ?
hThread        dd  ?
sw1            dd  ?

szRegPath      db  256 dup(?)
szRegValue     db  256 dup(?)
szRegSave      db  256 dup(?)
szIconPath     db  256 dup(?)
szOpenPath     db  256 dup(?)
szIconTemp     db  256 dup(?)
szFoldFile     db  256 dup(?)
szFileNameA    db  256 dup(?)
szRegExt       db  24  dup(?)
szExtent       db  24  dup(?)
szFileType     db  24  dup(?)
szZipPack      db  256 dup(?)
szZipUnPack    db  256 dup(?)
szPgmZip       db  256 dup(?)
szEditPgr      db  256 dup(?)

.code

;;===================================================
;; Center dialog PROCEDURE
;;===================================================
;CenterProc PROC hdlg:DWORD, wMsg, wParam, lParam
;
;      .if wMsg == WM_COMMAND
;            mov     eax, wParam
;            and     eax, 0ffffh
;         .if eax == IDCANCEL
;            INVOKE     DestroyWindow, hdlg
;               mov     eax, TRUE
;               ret
;         .endif
;      .endif
;         mov     eax, FALSE
;         ret
;
;CenterProc ENDP

DoFileOperation PROC

      INVOKE     CreateThread, NULL, NULL, addr ThreadProc, NULL, NULL, addr hThread
      INVOKE     CloseHandle, eax
         ret

DoFileOperation ENDP

;===================================================
; File Operations for Copy Move Rename Delete items Procedure
;===================================================
;DoFileOperation PROC uses ebx esi edi
ThreadProc PROC uses ebx esi edi

LOCAL    rect:RECT
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    Lft:FILETIME
LOCAL    ShFileOp:SHFILEOPSTRUCT
LOCAL    SelCnt:DWORD, SelDel, Cnt, hConfirm, CpyNum, Val, AbortCode
LOCAL    szToDate[50]:BYTE, szFrDate[50]:BYTE, szSavPath[256]:BYTE

         mov     FileOper, 1
         and     hCenter, 0
         and     hConfirm, 0
         and     DupeCode, 0
         and     FolderOn, 0
         and     ProgPos, 0
         and     CpyNum, 0
         and     hCopy, 0

     .if Funct == IDM_RENAMEE        ; From edit field
        INVOKE     lstrcpy, addr szOpenPath, addr szRootPath
           mov     SelCnt, 1
           jmp     NoCheck
     .endif
      .if Funct == IDM_COPY || Funct == IDM_MOVE
          MOVmd     hConfirm, ShowConfC
            xor     hConfirm, 1
      .endif
      .if Funct == IDM_PASTE
         INVOKE     lstrcpy, addr szRootPath, addr szBuffTo
            mov     SelCnt, 1
;            mov     Funct, IDM_COPY
            jmp     FromPaste
      .endif
      .if Funct == IDM_DELETE
          MOVmd     hConfirm, ShowConfD
      .endif
      .if DragFrTree
            mov     SelCnt, 1
            jmp     LoopSel
      .endif
      .if DragToTree
           and     DropOn, 0
      .endif
      .if DragInTree
         INVOKE     lstrcpy, addr szRootPath, addr szBuffFr
         INVOKE     lstrlen, addr szRootPath
         INVOKE     lstrcpyn, addr szRootPath, addr szRootPath, eax
         INVOKE     lstrcpy, addr szBuffFr, addr szRootPath
           call     GetFileName
         INVOKE     lstrcpy, addr szListFrom, addr szFileName
         INVOKE     lstrcat, addr szBuffTo, addr szFileName
            mov     SelCnt, 1
            mov     FolderOn, 1
            jmp     Pass4
      .endif

      .if DragToTree && !ActiveList
         INVOKE     lstrcpy, addr szSavPath, addr szListPathR
         INVOKE     lstrcpy, addr szListPathR, addr szRootPath
      .elseif DragToTree
         INVOKE     lstrcpy, addr szSavPath, addr szListPathL
         INVOKE     lstrcpy, addr szListPathL, addr szRootPath
      .endif

         mov     esi, ActiveList
      INVOKE     SendMessage, hWndListL[esi*4], CM_CHECKSELECT, 0, addr SelArray
      .if !eax
            jmp     NoSelection
      .endif
         mov     ListSelTot, eax
      .if Funct == IDM_EXPLODE
           call     Explode
            jmp     Ret0
      .endif
         mov     SelCnt, eax
         mov     SelDel, eax
         and     Cnt, 0
         mov     szListFrom, 0
      .if SelCnt > 1
         INVOKE     BaseAscii, SelCnt, addr CopyNum, 4, 10, 1, 0, 1
         INVOKE     lstrcpy, addr szListFrom, addr CopyFiles
         INVOKE     lstrcat, addr szListFrom, addr CopyNum
         INVOKE     lstrcat, addr szListFrom, addr Files
      .endif

LoopSel:
      .if !ActiveList
         INVOKE     lstrcpy, addr szBuffFr, addr szListPathL
         INVOKE     lstrcpy, addr szBuffTo, addr szListPathR
      .else
         INVOKE     lstrcpy, addr szBuffFr, addr szListPathR
         INVOKE     lstrcpy, addr szBuffTo, addr szListPathL
      .endif

      .if DragFrTree
         .if !HitList
            INVOKE     lstrcpy, addr szBuffFr, addr szListPathL
            INVOKE     lstrcpy, addr szBuffTo, addr szListPathL
         .else
            INVOKE     lstrcpy, addr szBuffFr, addr szListPathR
            INVOKE     lstrcpy, addr szBuffTo, addr szListPathR
         .endif
      .endif

;---------- [Drag and Drop
      .if DropOn
            mov     szFolder, 0
            mov     esi, HitList
            mov     edi, HitRow
            shl     edi, 16
         .if esi != ActiveList && HitRow == 88888
         .elseif esi == ActiveList && HitRow != 88888 || esi != ActiveList && HitRow != 88888
            .if esi == ActiveList && !DragFrTree
               INVOKE     lstrcpy, addr szBuffTo, addr szBuffFr
            .endif
            INVOKE     SendMessage, hWndListL[esi*4], CM_GETCELLDATA, edi, addr szFolder
            .if szFolder
               INVOKE     lstrcat, addr szFolder, addr szSlashB
               INVOKE     lstrcat, addr szBuffTo, addr szFolder
            .endif
         .endif
         .if DragFrTree
            INVOKE     lstrlen, addr szRootPath
            INVOKE     lstrcpyn, addr szRootPath, addr szRootPath, eax
            INVOKE     lstrcpy, addr szBuffFr, addr szRootPath
              call     GetFileName
            INVOKE     lstrcpy, addr szListFrom, addr szFileName
            INVOKE     lstrcat, addr szBuffTo, addr szFileName
               mov     FolderOn, 1
               jmp     Pass4
         .endif
      .endif
;----------

         mov     esi, ActiveList
         mov     eax, Cnt
         mov     ebx, SelArray[eax*4]
         shl     ebx, 16
      INVOKE     SendMessage, hWndListL[esi*4], CM_GETCELLDATA, ebx, addr szFileName
         mov     bx, 5
      INVOKE     SendMessage, hWndListL[esi*4], CM_GETCELLDATA, ebx, addr Val
         and     Val, 0ffffh
      .if Val == 1
            jmp     ByPass
      .endif
      .if Val == 2
            mov     FolderOn, 1
      .endif

      INVOKE     lstrcpy, addr szOpenPath, addr szBuffTo
      INVOKE     lstrcat, addr szBuffTo, addr szFileName
      INVOKE     SetCurrentDirectory, addr szBuffFr
      INVOKE     lstrcat, addr szBuffFr, addr szFileName
      .if !szListFrom
         INVOKE     lstrcat, addr szListFrom, addr szFileName
      .endif

      .if Funct == IDM_RENAME || Funct == IDM_RENAMEE || Funct == IDM_DELETE
         INVOKE     lstrcpy, addr szOpenPath, addr szBuffFr
      .endif

      .if byte ptr szOpenPath == 'A' || byte ptr szOpenPath == 'a' ||\
          byte ptr szOpenPath == 'B' || byte ptr szOpenPath == 'b'
         INVOKE     CreateFile, addr szDummy,\
                    GENERIC_READ or GENERIC_WRITE ,\
                    FILE_SHARE_READ or FILE_SHARE_WRITE,\
                    0,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE, 0
         .if eax == INVALID_HANDLE_VALUE
            INVOKE     MessageBox, NULL, addr szRemError, addr AppName, MB_OK or MB_ICONSTOP
         .else
            INVOKE     CloseHandle, eax
            INVOKE     DeleteFile, addr szDummy
         .endif
      .endif

      .if Funct == IDM_DELETE
         .if SelDel > 0 && hConfirm
            INVOKE     MessageBox, hWnd, addr szDeleteD, addr AppName, MB_YESNO or MB_ICONQUESTION
            .if eax == IDNO
                  jmp     ByPass
            .endif
               and     SelDel, 0
         .endif
            jmp     NoCheck
      .endif 

Pass4:
      .if !hConfirm
         INVOKE     DialogBoxParam, hInst, IDD_CONFIRM, hWnd, offset ConfirmDlg, 0
         .if eax == IDCANCEL
               and     Funct, 0
               jmp     Ret0
         .endif
            mov     hConfirm, 1
      .endif

.if DragFrTree 
;      jmp     NoCheck
.endif

;---------- [Copy Move Rename Delete items
      .if Funct == IDM_RENAME
            jmp     NoCheck
      .endif

;      .if !hCopy && ShowProgess
;         INVOKE     CreateDialogParam, hInst, IDD_COPY, hWnd, offset CopyDlg, 0
;      .elseif ShowProgess
;         INVOKE     CopyDlg, hCopy, WM_PAINT, 0, 0
;      .endif

;---------- [Get from directory file size, date, and time
      INVOKE     FindFirstFile, addr szBuffFr, addr FindData
      INVOKE     FindClose, eax
         mov     eax, MAXDWORD
        imul     eax, FindData.nFileSizeHigh
         add     eax, FindData.nFileSizeLow
         mov     edx, eax
      INVOKE     BaseAscii, edx, addr szBuffFrST, 10, 10, 1, 0, 1
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
         INVOKE     lstrcpy, addr szBuffFrST, addr szDir
      .endif

      INVOKE     lstrcat, addr szBuffFrST, addr szBytes
      INVOKE     FileTimeToLocalFileTime, addr FindData.ftLastWriteTime, addr Lft
      INVOKE     FileTimeToSystemTime, addr Lft, addr time
        call     fmtime
         add     eax, 4                              ; Bypass the sort year
      INVOKE     lstrcpy, addr szFrDate, eax         ; eax = cdt.dmo from DATETIME struct
      INVOKE     lstrcat, addr szBuffFrST, addr szFrDate

;---------- [Get to directory file size, date, and time
      INVOKE     FindFirstFile, addr szBuffTo, addr FindData
        test     eax, eax
          js     NoDupe
      INVOKE     FindClose, eax
         mov     eax, MAXDWORD
        imul     eax, FindData.nFileSizeHigh
         add     eax, FindData.nFileSizeLow
         mov     edx, eax
      INVOKE     BaseAscii, edx, addr szBuffToST, 10, 10, 1, 0, 1
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
         INVOKE     lstrcpy, addr szBuffToST, addr szDir
      .endif  
      INVOKE     lstrcat, addr szBuffToST, addr szBytes
      INVOKE     FileTimeToLocalFileTime, addr FindData.ftLastWriteTime, addr Lft
      INVOKE     FileTimeToSystemTime, addr Lft, addr time
        call     fmtime
         add     eax, 4                              ; Bypass the sort year
      INVOKE     lstrcpy, addr szToDate, eax         ; eax = cdt.dmo from DATETIME struct
      INVOKE     lstrcat, addr szBuffToST, addr szToDate

      .if DupeCode == 10
            jmp     NoDupe
      .elseif DupeCode == 12
            jmp     ChkDate
      .endif
         and     DupeCode, 0
      INVOKE     DialogBoxParam, hInst, IDD_DUPE, hWnd, offset DupeDlg, 0
      .if eax == IDCANCEL || DupeCode == 13    ; 13 = Skip all
;         .if hCopy
;            INVOKE     EndDialog, hCopy, IDCANCEL
;         .endif
            and     Funct, 0
            jmp     Ret0
      .elseif DupeCode == 10                   ; 10 = Overwrite all
            jmp     NoDupe
      .elseif DupeCode == 11                   ; 11 = Skip
            jmp     ByPass
      .elseif DupeCode == 12                   ; 12 = Overwrite all older
            jmp     ChkDate
      .endif
         jmp     NoDupe

ChkDate:
      INVOKE     lstrcpy, addr szWork, addr szFrDate
      INVOKE     lstrcpy, addr szFrDate, addr szWork+6
      INVOKE     lstrcpyn, addr szFrDate+4, addr szWork, 6
      INVOKE     lstrcpyn, addr szFrDate+9, addr szWork+11, 9
      INVOKE     lstrcpy, addr szWork, addr szToDate
      INVOKE     lstrcpy, addr szToDate, addr szWork+6
      INVOKE     lstrcpyn, addr szToDate+4, addr szWork, 6
      INVOKE     lstrcpyn, addr szToDate+9, addr szWork+11, 9
      INVOKE     lstrcmpi, addr szFrDate, addr szToDate
      .if eax == 0 || sdword ptr eax < 0
            jmp     ByPass
      .endif

NoDupe:
         xor     edx, edx
         mov     eax, CpyNum
         inc     eax
        imul     eax, 100
         mov     ebx, ListSelTot
      .if ebx == 0
            inc     ebx
      .endif
         div     ebx
         mov     ProgPos, eax

;      .if ShowProgess
;         INVOKE     CopyDlg, hCopy, WM_PAINT, 0, 0 ; Update the copy dialog
;         .if eax == IDCANCEL
;            INVOKE     EndDialog, hCopy, IDCANCEL
;               and     Funct, 0
;               jmp     Ret0
;         .endif
;      .endif

NoCheck:
      .if Funct != IDM_RENAME && Funct != IDM_RENAMEE ;&& !DragFrTree
         INVOKE     lstrcpy, addr szRootPath, addr szBuffTo
           call     RemFileName
      .endif

FromPaste:
      .if Funct == IDM_COPY || Funct == IDM_MOVE || Funct == IDM_PASTE
         INVOKE     lstrcpy, addr szOpenPath, addr szBuffFr
      .endif

      INVOKE     lstrlen, addr szBuffFr
         inc     eax
         mov     szBuffFr[eax], 0         ; Insert additional terminator
      INVOKE     lstrlen, addr szRootPath ;szBuffTo
         inc     eax
         mov     szRootPath[eax], 0       ; Insert additional terminator

      .if Funct == IDM_COPY || Funct == IDM_PASTE
            mov     ShFileOp.wFunc, FO_COPY
      .elseif Funct == IDM_MOVE
            mov     ShFileOp.wFunc, FO_MOVE
      .elseif Funct == IDM_RENAME || Funct == IDM_RENAMEE
            mov     ShFileOp.wFunc, FO_RENAME
      .elseif Funct == IDM_DELETE
            mov     ShFileOp.wFunc, FO_DELETE
      .else
            and     Funct, 0
            jmp     Ret0
      .endif

      .if !hCenter && Funct == IDM_COPY || !hCenter && Funct == IDM_MOVE || !hCenter && Funct == IDM_DELETE
;            mov     ecx, ActiveList
;         INVOKE     CreateDialogParam, hInst, 4804, hWndListL[ecx*4], offset CenterProc, 0
;            mov     hCenter, eax

         INVOKE     GetSystemMetrics, SM_CXSCREEN
            sub     eax, 10
            shr     eax, 1
           push     eax
         INVOKE     GetSystemMetrics, SM_CYSCREEN
            sub     eax, 10
            shr     eax, 1
            pop     ebx
            mov     ecx, eax

            mov     edx, ActiveList
         INVOKE     CreateWindowEx, 0, addr StaticClass, 0, WS_POPUP,\
                    ebx, ecx, 10, 10, hWndListL[edx*4], 0, hInst, 0
            mov     hCenter, eax

;         INVOKE     ShowWindow, hCenter, SW_HIDE
         INVOKE     GetWindowRect, hCenter, addr rect
            sub     rect.left, 202 ;140
            sub     rect.top, 100
            mov     eax, rect.left
            add     eax, 202 ;140
            sub     rect.right, eax
            mov     eax, rect.top
            add     eax, 100
            sub     rect.bottom, eax
         INVOKE     MoveWindow, hCenter, rect.left, rect.top, rect.right, rect.bottom, TRUE
      .endif

         mov     eax, ActiveList
      INVOKE     SetFocus, hWndListL[eax*4]

      INVOKE     LoadCursor, 0, IDC_WAIT
      INVOKE     SetCursor, eax
         mov     ShFileOp.hwnd, 0         ; If 0, then no parent can task switch away

mov     eax, hCenter
mov     ShFileOp.hwnd, eax

         lea     eax, szBuffFr
         mov     ShFileOp.pFrom, eax
         lea     eax, szRootPath ;szBuffTo
         mov     ShFileOp.pTo, eax
         lea     eax, AbortCode
         mov     ShFileOp.fAnyOperationsAborted, eax
         mov     ShFileOp.fFlags, FOF_NOCONFIRMATION
      .if !ShowProgess
             or     ShFileOp.fFlags, FOF_SILENT
      .endif
      .if CopyToRecycle
             or     ShFileOp.fFlags, FOF_ALLOWUNDO
      .endif
      INVOKE     SHFileOperation, addr ShFileOp
      .if eax == 0
            add     CpyNum, 1
      .elseif eax == 1223    ; Canceled
            mov     ecx, ActiveList
         INVOKE     RedrawWindow, hWndListL[ecx*4], 0, 0, RDW_INVALIDATE or RDW_UPDATENOW
      .endif
         mov     eax, ActiveList
      INVOKE     SetFocus, hWndListL[eax*4]
      INVOKE     LoadCursor, 0, IDC_ARROW
      INVOKE     SetCursor, eax

ByPass:
         dec     SelCnt
         inc     Cnt
      .if SelCnt
            jmp     LoopSel
      .endif

      .if hCenter
;DSPValue hWnd, 8888, 1, 'm'
;         INVOKE     CenterProc, hCenter, WM_COMMAND, IDCANCEL, 0
         INVOKE     DestroyWindow, hCenter
;DSPValue hWnd, 9999, 1, 'm'
            and     hCenter, 0
      .endif

;      .if hCopy
;         INVOKE     EndDialog, hCopy, IDCANCEL
;      .endif

        call     CopyBack

;jmp     Pass44

      .if Funct == IDM_MOVE || Funct == IDM_RENAME || Funct == IDM_DELETE ;|| Funct == IDM_RENAMEE
         INVOKE     DoSHNotify, 0, SHCNE_DELETE
      .endif
         mov     eax, ActiveList
      .if Funct == IDM_COPY || Funct == IDM_MOVE || Funct == IDM_PASTE
         .if DropOn && eax == HitList && !DragFrTree
         .else
.if Funct != IDM_PASTE
              push     ActiveList
               xor     ActiveList, 1
            INVOKE     DoSHNotify, 0, SHCNE_CREATE
               pop     ActiveList
.endif
              call     ChkTool
            .if DragFrTree || DragInTree || Funct == IDM_PASTE
               INVOKE     DoSHNotify, 0, SHCNE_CREATE
            .endif
         .endif
      .endif
Pass44:
MOVmd     FunctT, Funct
         jmp     Ret0

NoSelection:
      INVOKE     MessageBox, NULL, addr szNoSelect, addr AppName, MB_OK or MB_ICONWARNING or MB_TASKMODAL

Ret0:
        call     CopyBack
      .if TreeviewOn
         .if FolderOn
            .if Funct == IDM_COPY || Funct == IDM_MOVE
                  mov     DropOn, 1
               .if !DragFrTree
                     and     HitList, 0
                  .if !ActiveList
                        mov     HitList, 1
                  .endif
               .endif
            .endif
              call     RefreshBranch
         .endif
         .if  !ActiveList
               mov     eax, hItemL
         .else
               mov     eax, hItemR
         .endif
         INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, eax
      .endif
         and     HitList, 0
         and     DropOn, 0
         and     Funct, 0

      INVOKE     ExitThread, 0
         xor     eax, eax
         ret

CopyBack:
      .if DragToTree && !ActiveList
         INVOKE     lstrcpy, addr szListPathR, addr szSavPath
      .elseif DragToTree
         INVOKE     lstrcpy, addr szListPathL, addr szSavPath
      .endif
        retn

;DoFileOperation ENDP
ThreadProc ENDP

;===================================================
; Confirm For Copy - Move - Rename File Procedure
;===================================================
ConfirmDlg PROC hdlg:DWORD, wMsg, wParam, lParam
LOCAL    rect:RECT
LOCAL    hDC:DWORD
LOCAL    szBuff[256]:BYTE

      .if wMsg == WM_INITDIALOG
         .if !ActiveList
            INVOKE     lstrcpy, addr szRootPath, addr szListPathL
            .if Funct == IDM_COPY || Funct == IDM_MOVE
               INVOKE     lstrcpy, addr szRootPath, addr szListPathR
            .endif
         .else
            INVOKE     lstrcpy, addr szRootPath, addr szListPathR
            .if Funct == IDM_COPY || Funct == IDM_MOVE
               INVOKE     lstrcpy, addr szRootPath, addr szListPathL
            .endif
         .endif
         .if DropOn || DragInTree
            INVOKE     lstrcpy, addr szRootPath, addr szBuffTo
              call     RemFileName
         .endif
         .if Funct == IDM_RENAME
            INVOKE     lstrcat, addr szRootPath, addr szFileName
         .endif
         .if Funct == 5040   ; 5040 = Pack
            INVOKE     lstrcat, addr szRootPath, addr szTemp
         .endif
         INVOKE     SetDlgItemText, hdlg, IDC_EDIT40, addr szRootPath

      .elseif wMsg == WM_SETFOCUS
            jmp     DrawIt

      .elseif wMsg == WM_PAINT
            jmp     DrawIt

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
           cwde
         .if eax == IDOK
            INVOKE     GetDlgItemText, hdlg, IDC_EDIT40, addr szBuff, sizeof szBuff
.if Funct == 106
            INVOKE     lstrcmpi, addr szBuff, addr szRootPath
            .if !eax
; Do message no change
                  jmp     DlgDone
            .endif
.endif
               .if Funct == 5040   ; 5040 = Pack
                  INVOKE     lstrcpy, addr szWork, addr szBuff
                     jmp     CancelOut
               .endif
               INVOKE     lstrcpy, addr szRootPath, addr szBuff
               .if Funct != IDM_RENAME && Funct != IDM_MAKEDIR && !DragFrTree
                  INVOKE     lstrcat, addr szRootPath, addr szFileName
               .endif
                  jmp     CancelOut
;            .endif

         .elseif eax == IDCANCEL
               mov     szRootPath, 0
               jmp     CancelOut
         .endif

      .elseif wMsg == WM_CLOSE
            jmp     CancelOut
      .endif
         jmp     DlgDone

DrawIt:
      INVOKE     GetDC, hdlg
         mov     hDC, eax
      INVOKE     SelectObject, hDC, hFontM
        push     eax
      INVOKE     GetClientRect, hdlg, addr rect
         mov     rect.left, 25
         mov     rect.top, 8
         mov     rect.bottom, 35
      INVOKE     GetSysColor, COLOR_BTNFACE
      INVOKE     SetBkColor, hDC, eax
      INVOKE     SetTextColor, hDC, 00000000h
      INVOKE     DrawText, hDC, addr szWork, -1, addr rect, DT_LEFT or DT_SINGLELINE

      .if Funct != IDM_MAKEDIR
            add     rect.left, 42
         .if Funct == IDM_RENAME
            add     rect.left, 20
         .endif
         INVOKE     SetTextColor, hDC, 00ff0000h
         INVOKE     DrawText, hDC, addr szListFrom, -1, addr rect, DT_LEFT or DT_SINGLELINE
      .endif
         pop     eax
      INVOKE     SelectObject, hDC, eax
      INVOKE     ReleaseDC, hdlg, hDC
         jmp     DlgDone

CancelOut:
      INVOKE     EndDialog, hdlg, wParam
         mov     eax, TRUE
         jmp     DlgRet

DlgDone:
         mov     eax, FALSE

DlgRet:
         ret

ConfirmDlg ENDP

;===================================================
; CopyDlg  Copy File Procedure
;===================================================
CopyDlg PROC    hdlg:DWORD, wMsg, wParam, lParam
LOCAL    rect:RECT
LOCAL    hDC:DWORD
LOCAL    szClear[350]:BYTE, szBuff1[256]:BYTE, szBuff2[256]:BYTE

         cmp     wMsg, WM_INITDIALOG   ; If message is INITDIALOG then
         jne     @1                    ; check wMsg

      INVOKE     GetWindowRect, hdlg, addr rect
         mov     eax, rect.left
         sub     rect.right, eax
         mov     eax, rect.top
         sub     rect.bottom, eax
         mov     eax, rect.bottom
         add     eax, 5 ;4
         sub     rect.top, eax
      INVOKE     MoveWindow, hdlg, rect.left, rect.top, rect.right, rect.bottom, TRUE
         jmp     DlgDone

@1:
         cmp     wMsg, WM_SETFOCUS
         je      OutPut
         cmp     wMsg, WM_PAINT
         je      OutPut
         cmp     wMsg, WM_COMMAND      ;Is message a WM_COMMAND?
         jne     DlgDone ;OutPut       ;No, then just return

         mov     eax, wParam           ; Otherwise, see if it's OK or CANCEL
         cmp     eax, IDCANCEL         ; that was pressed
         je      CancelIt              ; and if not either of these
         jmp     DlgDone               ; return
        
CancelIt:
         and     hCopy, 0
      INVOKE     EndDialog, hdlg, wParam
         mov     eax, TRUE             ; return
         jmp     DlgRet                ; with TRUE

OutPut:
       MOVmd     hCopy, hdlg
      INVOKE     GetDC, hdlg
         mov     hDC, eax
      INVOKE     SelectObject, hDC, hFontM
        push     eax
      INVOKE     GetClientRect, hdlg, addr rect
         mov     rect.left, 175
         mov     rect.top, 4

      INVOKE     GetSysColor, COLOR_BTNFACE ;COLOR_INACTIVECAPTIONTEXT
      INVOKE     SetBkColor, hDC, eax
      .if Funct == 0 || Funct == IDM_COPY || Funct == IDM_MOVE
         INVOKE     DrawText, hDC, addr szWork, -1, addr rect, DT_LEFT or DT_SINGLELINE
      .endif
      INVOKE     GetSysColor, COLOR_HIGHLIGHT
      INVOKE     SetTextColor, hDC, eax
         mov     rect.left, 36
         mov     rect.top, 22
         mov     rect.bottom, 52
      INVOKE     FillBuffer, addr szClear, sizeof szClear, ' ', 1
      .if !ActiveList
         INVOKE     lstrcpy, addr szBuff1, addr szListPathL
         INVOKE     lstrcpy, addr szBuff2, addr szListPathR
      .else
         INVOKE     lstrcpy, addr szBuff1, addr szListPathR
         INVOKE     lstrcpy, addr szBuff2, addr szListPathL
      .endif
      INVOKE     lstrcat, addr szBuff1, addr szFileName
      .if FolderOn
         INVOKE     lstrcat, addr szBuff2, addr szFolder
      .endif
      .if DragFrTree || DragInTree
         INVOKE     lstrcpy, addr szBuff1, addr szBuffFr
         INVOKE     lstrcpy, addr szRootPath, addr szBuffTo
           call     RemFileName
         INVOKE     lstrcpy, addr szBuff2, addr szRootPath
      .endif
      INVOKE     DrawText, hDC, addr szClear, -1, addr rect, DT_LEFT or DT_EDITCONTROL or DT_WORDBREAK
      INVOKE     DrawText, hDC, addr szBuff1, -1, addr rect, DT_LEFT or DT_EDITCONTROL or DT_WORDBREAK
         mov     rect.top, 53
         mov     rect.bottom, 82
      INVOKE     DrawText, hDC, addr szClear, -1, addr rect, DT_LEFT or DT_EDITCONTROL or DT_WORDBREAK
      INVOKE     DrawText, hDC, addr szBuff2, -1, addr rect, DT_LEFT or DT_EDITCONTROL or DT_WORDBREAK
      INVOKE     SendDlgItemMessage, hdlg, IDC_TO, PBM_SETPOS, 0, 0
      INVOKE     SendDlgItemMessage, hdlg, IDC_TO, PBM_SETPOS, ProgPos, 0
         pop     eax
      INVOKE     SelectObject, hDC, eax
      INVOKE     ReleaseDC, hdlg, hDC

DlgDone:
         mov     eax, FALSE
DlgRet:
         ret

CopyDlg ENDP

;===================================================
; DupeDlg Allows For Override Of Duplicate Files Procedure
;===================================================
DupeDlg PROC hdlg:DWORD, wMsg, wParam, lParam
LOCAL    rect:RECT
LOCAL    hDC:DWORD
LOCAL    szClear[350]:BYTE, szBuff1[256]:BYTE, szBuff2[256]:BYTE

         cmp     wMsg, WM_SETFOCUS
         je      OutPut
         cmp     wMsg, WM_PAINT
         je      OutPut
         cmp     wMsg, WM_COMMAND      ; Is message a WM_COMMAND?
         jne     DlgDone               ; No, then just return

         mov     eax, wParam           ; Otherwise, see if it's OK or CANCEL
         and     eax, 0ffffh
         cmp     eax, IDCANCEL         ; that was pressed
         je      CancelIt              ; and if not either of these
      .if eax > 9 && eax < 14
            mov     DupeCode, eax
            jmp     CancelIt
      .endif
         cmp     eax, IDOK             ; then just
         jne     DlgDone               ; Return
        
CancelIt:
      INVOKE     EndDialog, hdlg, wParam
         mov     eax, TRUE             ; Return
         jmp     DlgRet                ; with TRUE

OutPut:
      INVOKE     GetDC, hdlg
         mov     hDC, eax
      INVOKE     SelectObject, hDC, hFontM
        push     eax
      INVOKE     GetClientRect, hdlg, addr rect
         mov     rect.left, 56

      INVOKE     GetSysColor, COLOR_BTNFACE ;COLOR_INACTIVECAPTIONTEXT
      INVOKE     SetBkColor, hDC, eax

      INVOKE     SetTextColor, hDC, 000000ffh
         mov     rect.top, 7
         mov     rect.bottom, 37
      INVOKE     DrawText, hDC, addr szBuffTo, -1, addr rect, DT_LEFT or DT_EDITCONTROL or DT_WORDBREAK
         mov     rect.top, 22
         mov     rect.bottom, 37
      INVOKE     lstrlen, addr szBuffTo
      .if eax > 52
            mov     rect.top, 36
            mov     rect.bottom, 51
      .endif
      INVOKE     SetTextColor, hDC, 00ff0000h
      INVOKE     DrawText, hDC, addr szBuffToST, -1, addr rect, DT_LEFT or DT_SINGLELINE

      INVOKE     SetTextColor, hDC, 00008000h
         mov     rect.top, 49
         mov     rect.bottom, 79
      INVOKE     DrawText, hDC, addr szBuffFr, -1, addr rect, DT_LEFT or DT_EDITCONTROL or DT_WORDBREAK
         mov     rect.top, 64
         mov     rect.bottom, 79
      INVOKE     lstrlen, addr szBuffFr
      .if eax > 52
            mov     rect.top, 78
            mov     rect.bottom, 93
      .endif
      INVOKE     SetTextColor, hDC, 00ff0000h
      INVOKE     DrawText, hDC, addr szBuffFrST, -1, addr rect, DT_LEFT or DT_SINGLELINE
         pop     eax
      INVOKE     SelectObject, hDC, eax
      INVOKE     ReleaseDC, hdlg, hDC

DlgDone:
         mov     eax, FALSE            ; Return with FALSE
DlgRet:
         ret

DupeDlg ENDP

;===================================================
; Change attributes date/time Procedure
;===================================================
AttributesDlg PROC  uses ebx  hdlg:DWORD, wMsg, wParam, lParam
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    ft:FILETIME
LOCAL    Lft:FILETIME
LOCAL    dwAttr:DWORD, hFile, w1
LOCAL    szFrDate[50]:BYTE, szFrTime[50]:BYTE, szAttr[12]:BYTE, szConv[22]:BYTE

      .if wMsg == WM_INITDIALOG
            mov     esi, ActiveList
         INVOKE     SendMessage, hWndListL[esi*4], CM_CHECKSELECT, 0, addr SelArray
         .if !eax
            INVOKE     MessageBox, NULL, addr szNoSelect, addr AppName, MB_OK or MB_ICONWARNING or MB_TASKMODAL
               jmp     CancelIt
         .endif
         .if !ActiveList
            INVOKE     lstrcpy, addr szRootPath, addr szListPathL
         .else
            INVOKE     lstrcpy, addr szRootPath, addr szListPathR
         .endif
            mov     ecx, SelArray
            shl     ecx, 16
         INVOKE     SendMessage, hWndListL[esi*4], CM_GETCELLDATA, ecx, addr szFileName
         INVOKE     lstrcat, addr szRootPath, addr szFileName
         INVOKE     FindFirstFile, addr szRootPath, addr FindData
         .if eax == -1
               jmp     CancelIt
         .endif
         .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE)
            INVOKE     GetDlgItem, hdlg, 601
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif
         .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_READONLY)
            INVOKE     GetDlgItem, hdlg, 602
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif
         .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN)
            INVOKE     GetDlgItem, hdlg, 603
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif
         .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM)
            INVOKE     GetDlgItem, hdlg, 604
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif
         INVOKE     FileTimeToLocalFileTime, addr FindData.ftLastWriteTime, addr Lft
         INVOKE     FileTimeToSystemTime, addr Lft, addr time
           call     fmtime
            add     eax, 4                            ; Bypass the sort year
         INVOKE     lstrcpy, addr szWork, eax         ; eax = cdt.dmo from DATETIME struct
         INVOKE     lstrcpyn, addr szFrDate, addr szWork, 11
         INVOKE     SetDlgItemText, hdlg, 801, addr szFrDate
         INVOKE     lstrcpy, addr szFrTime, addr szWork+11
         INVOKE     SetDlgItemText, hdlg, 802, addr szFrTime
            jmp     DlgDone

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
            and     eax, 0ffffh

         .if eax == IDCANCEL
               jmp     CancelIt

         .elseif eax == IDOK
            INVOKE     SetFileAttributes, addr szRootPath, FILE_ATTRIBUTE_ARCHIVE
               mov     dwAttr, 0
            INVOKE     lstrcpy, addr szAttr, addr szFill

            INVOKE     IsDlgButtonChecked, hdlg, 601
            .if eax == BST_CHECKED
                   or     dwAttr, FILE_ATTRIBUTE_ARCHIVE
                  mov     byte ptr[szAttr+1], 'a'
            .endif
            INVOKE     IsDlgButtonChecked, hdlg, 602
            .if eax == BST_CHECKED
                   or     dwAttr, FILE_ATTRIBUTE_READONLY
                  mov     byte ptr[szAttr], 'r'
            .endif
            INVOKE     IsDlgButtonChecked, hdlg, 603
            .if eax == BST_CHECKED
                   or     dwAttr, FILE_ATTRIBUTE_HIDDEN
                  mov     byte ptr[szAttr+2], 'h'
            .endif
            INVOKE     IsDlgButtonChecked, hdlg, 604
            .if eax == BST_CHECKED
                   or     dwAttr, FILE_ATTRIBUTE_SYSTEM
                  mov     byte ptr[szAttr+3], 's'
            .endif

               mov     esi, ActiveList
               mov     ecx, SelArray
               shl     ecx, 16
               mov     cx, 4
            INVOKE     SendMessage, hWndListL[esi*4], CM_SETCELLDATA, ecx, addr szAttr

            INVOKE     IsDlgButtonChecked, hdlg, 605
            .if eax == BST_CHECKED
               INVOKE     CreateFile, addr szRootPath, GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE,
                          0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0	
                  mov     hFile, eax

               INVOKE     GetDlgItemText, hdlg, 801, addr szFrDate, sizeof szFrDate
               INVOKE     GetDlgItemText, hdlg, 802, addr szFrTime, sizeof szFrTime

               INVOKE     lstrcpy, addr szConv, addr szFrDate+6
               INVOKE     AsciiBase, addr szConv, addr w1, 10
                MOVmw     time.wYear, word ptr w1
               INVOKE     lstrcpyn, addr szConv, addr szFrDate, 3
               INVOKE     AsciiBase, addr szConv, addr w1, 10
                MOVmw     time.wMonth, word ptr w1
               INVOKE     lstrcpyn, addr szConv, addr szFrDate+3, 3
               INVOKE     AsciiBase, addr szConv, addr w1, 10
                MOVmw     time.wDay, word ptr w1

               INVOKE     lstrcpyn, addr szConv, addr szFrTime, 3
               INVOKE     AsciiBase, addr szConv, addr w1, 10
                MOVmw     time.wHour, word ptr w1
               INVOKE     lstrcpyn, addr szConv, addr szFrTime+3, 3
               INVOKE     AsciiBase, addr szConv, addr w1, 10
                MOVmw     time.wMinute, word ptr w1
               INVOKE     lstrcpyn, addr szConv, addr szFrTime+6, 3
               INVOKE     AsciiBase, addr szConv, addr w1, 10
                MOVmw     time.wSecond, word ptr w1

               INVOKE     SystemTimeToFileTime, addr time, addr ft
               INVOKE     LocalFileTimeToFileTime, addr ft, addr Lft

               INVOKE     SetFileTime, hFile, 0, 0, addr Lft
               INVOKE     CloseHandle, hFile

               INVOKE     lstrcpy, addr szConv, addr szFrDate+6  ; Add sort year
               INVOKE     lstrcat, addr szConv, addr szFrDate
               INVOKE     lstrcat, addr szConv, addr szSpace
               INVOKE     lstrcat, addr szConv, addr szFrTime

                  mov     esi, ActiveList
                  mov     ecx, SelArray
                  shl     ecx, 16
                  mov     cx, 3
               INVOKE     SendMessage, hWndListL[esi*4], CM_SETCELLDATA, ecx, addr szConv
            .endif
            INVOKE     SetFileAttributes, addr szRootPath, dwAttr
               jmp     CancelIt
         .endif

      .elseif wMsg == WM_CLOSE
            jmp     CancelIt

      .endif
         jmp     DlgDone

CancelIt:
      INVOKE     EndDialog, hdlg, wParam
         mov     eax, TRUE
         jmp     DlgRet

DlgDone:
         mov     eax, FALSE
DlgRet:
         ret

AttributesDlg ENDP

;===================================================
; Change file type association Procedure
;===================================================
AssociationDlg PROC  USES ebx esi edi hdlg:DWORD, wMsg, wParam, lParam
LOCAL    sfi:SHFILEINFO
LOCAL    ft:FILETIME
LOCAL    ofn:OPENFILENAME
LOCAL    IndexNum:DWORD, PathSize, ValueSize, TotCnt, hFontZ, hDC, SavRet, Var, hReg, Butt45On
LOCAL    szBuff[256]:BYTE, szType[64]:BYTE, szNum[6]:BYTE

      .if wMsg == WM_INITDIALOG
            mov     esi, ActiveList
         INVOKE     SendMessage, hWndListL[esi*4], CM_CHECKSELECT, 0, addr SelArray
         .if !eax
               jmp     NoSelect
         .endif
         .if !ActiveList
            INVOKE     lstrcpy, addr szRootPath, addr szListPathL
         .else
            INVOKE     lstrcpy, addr szRootPath, addr szListPathR
         .endif
            mov     ecx, SelArray
            shl     ecx, 16
         INVOKE     SendMessage, hWndListL[esi*4], CM_GETCELLDATA, ecx, addr szFileNameA
         INVOKE     lstrcat, addr szRootPath, addr szFileNameA
           call     GetExtent
         .if !szExt || byte ptr szFileNameA == '[' && byte ptr szFileNameA+1 == '.'
               jmp     NoSelect
         .endif
         INVOKE     SHGetFileInfo, addr szRootPath, 0, addr sfi, sizeof SHFILEINFO,\
                    SHGFI_SYSICONINDEX or SHGFI_SMALLICON ;or SHGFI_ICON or SHGFI_ATTRIBUTES	
          MOVmd     SavIcon, sfi.hIcon
          MOVmd     SavIconID, sfi.iIcon
;DSPValue hWnd, 2222, 1, 'm'
;DSPValue hWnd, SavIconID, 1, 'm'
;            mov     eax, sfi.dwAttributes
;            and     eax, 0ffffh
;         .if eax == 017fh
;            INVOKE     lstrcat, addr szExt, addr szFolderT
;         .endif
            and     sw1, 0
            and     DelKey, 0
            and     Butt45On, 0
            mov     szIconPath, 0
            mov     szNum, 0
         INVOKE     GetDlgItem, hdlg, 44
            mov     hButtE, eax
         INVOKE     GetDlgItem, hdlg, 45
            mov     hButtI, eax
         INVOKE     GetDlgItem, hdlg, 15
            mov     hCombo, eax
         INVOKE     GetDlgItem, hdlg, 16
            mov     hList, eax
         INVOKE     SendMessage, hCombo, WM_SETFONT, hFontM, TRUE
         INVOKE     SendMessage, hList, WM_SETFONT, hFontM, TRUE

ReLoad:
         INVOKE     SendMessage, hCombo, CB_ADDSTRING, 0, addr szSpace
         INVOKE     SendMessage, hList, LB_ADDSTRING, 0, addr szNone
            and     Var, 0
            and     TotCnt, 0
            and     IndexNum, 0

LoopP:
            mov     PathSize, 256
            mov     ValueSize, 256
         INVOKE     RegEnumKeyEx, HKEY_CLASSES_ROOT, IndexNum, offset szRegPath, addr PathSize,\
                    0, offset szRegValue, addr ValueSize, addr ft
         .if eax == ERROR_NO_MORE_ITEMS
               jmp     NoMore
         .endif

         .if byte ptr szRegPath != '.' || eax != 0
               inc     IndexNum
               jmp     LoopP
         .endif     

         INVOKE     lstrcpy, addr szExt, addr szRegPath
            mov     lpcbData, 256
         INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, offset szRegPath, offset szRegSave, addr lpcbData
            mov     lpcbData, 50
         INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, offset szRegSave, addr szType, addr lpcbData
         .if eax != 0
               jmp     Pass
         .endif
         INVOKE     lstrcpy, offset szRegPath, offset szRegSave
         INVOKE     lstrcat, offset szRegPath, offset szRegSOC
            mov     lpcbData, 256
         INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, offset szRegPath, offset szRegValue, addr lpcbData
         .if eax != 0
               jmp     Pass
         .endif

         INVOKE     lstrcpy, addr szBuff, addr szBL
         INVOKE     lstrcat, addr szBuff, addr szExt
         INVOKE     lstrcat, addr szBuff, addr szBR
         INVOKE     lstrcat, addr szBuff, addr szType
         INVOKE     lstrcat, addr szBuff, addr szLparen
         INVOKE     lstrcat, addr szBuff, addr szRegValue
         INVOKE     lstrcat, addr szBuff, addr szRparen
         INVOKE     SendMessage, hCombo, CB_ADDSTRING, 0, addr szExt
         INVOKE     SendMessage, hList, LB_ADDSTRING, 0, addr szBuff
            inc     TotCnt

Pass:
            inc     IndexNum
            jmp     LoopP

NoMore:
           call     GetExtent
         INVOKE     lstrcpy, addr szRegExt, addr szExt

            cmp     sw1, 8
             je     BuildPath
         INVOKE     SetDlgItemText, hdlg, 800, addr szRegExt  ; Display the source extension

BuildPath:
         mov     lpcbData, 256
      INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, offset szRegExt, offset szRegSave, addr lpcbData
      INVOKE     lstrcpy, addr szRegValue, addr szRegSave     ; txtfile or txt_file
      INVOKE     lstrcat, addr szRegValue, addr szRegIcon
         mov     lpcbData, 256
      INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, offset szRegValue, offset szIconPath, addr lpcbData
      INVOKE     lstrlen, addr szIconPath
         mov     ecx, eax
         lea     edi, szIconPath
         mov     al, ','               ; Comma
         cld                           ; Increment edi
       repnz     scasb                 ; Repeat until byte = al(',')
      .if ecx > 0
           push     ecx
         .if !Butt45On
            INVOKE     lstrcpy, addr szNum, edi
         .endif
         INVOKE     lstrlen, addr szIconPath
            pop     ecx
            sub     eax, ecx
         INVOKE     lstrcpyn, addr szIconPath, addr szIconPath, eax
         .if byte ptr szIconPath == '"'
            INVOKE     lstrlen, addr szIconPath
               dec     eax
            INVOKE     lstrcpyn, addr szIconPath, addr szIconPath+1, eax
         .endif 
      .endif

;      INVOKE     lstrcpy, addr szRegValue, addr szRegSave
;      INVOKE     lstrcat, addr szRegValue, addr szRegSOC
;         mov     lpcbData, 256
;      INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, offset szRegValue, offset szOpenPath, addr lpcbData
;INVOKE     MessageBox,NULL, addr szOpenPath, offset szFileMan, MB_OK

      INVOKE     SetDlgItemText, hdlg, 804, addr szNum
      INVOKE     SetDlgItemText, hdlg, 805, addr szIconPath

      INVOKE     SendMessage, hCombo, CB_FINDSTRING, -1, addr szRegExt
         mov     SavRet, eax

      .if eax == CB_ERR
         INVOKE     SetWindowText, hCombo, addr szRegExt
         INVOKE     SetDlgItemText, hdlg, 801, addr szNoAssoc
         INVOKE     SetDlgItemText, hdlg, 805, addr szNoAssoc
            jmp     DspIcon
      .endif

;---------- [Set the selection for the list & combo boxes
         and     DelKey, 0
         mov     ebx, SavRet
      INVOKE     SendMessage, hCombo, CB_SETCURSEL, eax, 0
      INVOKE     SendMessage, hList, LB_SETCURSEL, ebx, 0
      INVOKE     SendMessage, hList, LB_GETTEXT, ebx, addr szBuff

      INVOKE     lstrcpy, addr szRegSave, addr szBuff
      INVOKE     lstrlen, addr szRegSave
         mov     ecx, eax
         lea     edi, szRegSave
         mov     al, '('               ; (
         cld                           ; Increment edi
       repnz     scasb                 ; Repeat until byte = al('(')
      .if ecx > 0                      ; Strip the parentheses
         INVOKE     lstrcpy, addr szBuff, edi
         INVOKE     lstrlen, addr szBuff
         INVOKE     lstrcpyn, addr szBuff ,addr szBuff, eax
      .endif
      INVOKE     SetDlgItemText, hdlg, 801, addr szBuff

      .if byte ptr szBuff == ' ' && byte ptr szBuff+1 == 'n'
            mov     DelKey, 1
            mov     szRegPath, 0
      .endif

         xor     eax, eax
      .if byte ptr szBuff == '"' || byte ptr szBuff == '\'
            inc     eax
      .endif
      INVOKE     lstrcpy, addr szRegSave, addr szBuff+[eax]
      INVOKE     lstrcpy, addr szExtent, addr szExe
         and     Var, 0

LoopC:
      INVOKE     lstrlen, addr szRegSave
         mov     ecx, eax
         lea     esi, szRegSave
      .while (ecx)
           push     ecx
         INVOKE     CompareString, LOCALE_USER_DEFAULT, NORM_IGNORECASE, esi, 4, offset szExtent, 4
            pop     ecx
         .if eax == 2             ; 2 = match
               lea     eax, szRegSave
               sub     esi, eax
               add     esi, 5
            INVOKE     lstrcpyn, addr szRegSave, addr szRegSave, esi
            INVOKE     lstrcpy, addr szRegPath, addr szRegSave

;***************************************************************************************
;            INVOKE     DeleteObject, SavIcon
            INVOKE     DestroyIcon, SavIcon
            INVOKE     ExtractIcon, hInst, addr szRegSave, 0        ; 0 returns the handle of the first icon
            .if !eax
               INVOKE     LoadIcon, NULL, IDI_APPLICATION
            .endif
               mov     SavIcon, eax
;***************************************************************************************

               jmp     DspIcon
         .endif
            inc     esi
            dec     ecx
      .endw
         inc     Var
      .if Var < 3
         .if Var == 1
            INVOKE     lstrcpy, addr szExtent, addr szDll
         .else
            INVOKE     lstrcpy, addr szExtent, addr szIco
         .endif
            jmp     LoopC
      .endif

DspIcon:
      .if hImageAssoc
         INVOKE     ImageList_Destroy, hImageAssoc
      .endif
      INVOKE     ImageList_Create, 24, 24, ILC_COLOR32 or ILC_MASK, 4, 4
         mov     hImageAssoc, eax
      INVOKE     ExtractIcon, hInst, addr szIconPath, -1      ; -1 returns the total number of icons
      INVOKE     SetDlgItemInt, hdlg, 803, eax, 0
      INVOKE     GetDlgItemInt, hdlg, 804, 0, TRUE
      INVOKE     ExtractIcon, hInst, addr szIconPath, eax     ; 0 - n returns the handle of the icon
         mov     hIcon2, eax

      .if sw1 < 7                 ; From initial load
          MOVmd     hIcon1, SavIcon
            jmp     HaveIcon
      .endif
      .if sw1 == 9
         INVOKE     ExtractIcon, hInst, addr szIconPath, -1   ; -1 returns the total number of icons
            mov     ebx, eax
         INVOKE     SetDlgItemInt, hdlg, 803, ebx, 0
         .if ebx == 1                                         ; One icon
            INVOKE     SetDlgItemInt, hdlg, 804, 0, 0
         .endif
         INVOKE     GetDlgItemText, hdlg, 804, addr szNum, sizeof szNum
         INVOKE     GetDlgItemInt, hdlg, 804, 0, TRUE
         INVOKE     ExtractIcon, hInst, addr szIconPath, eax  ; 0 - n returns the handle of the icon
            mov     hIcon2, eax                               ; Default icon
            jmp     HaveIcon
      .endif
      INVOKE     ExtractIcon, hInst, addr szRegSave, 0        ; 0 returns the handle of the first icon 
         mov     hIcon1, eax                                  ; Open icon

HaveIcon:
      INVOKE     ImageList_AddIcon, hImageAssoc, hIcon1
      INVOKE     ImageList_AddIcon, hImageAssoc, hIcon2
      INVOKE     DeleteObject, hIcon1
      INVOKE     DeleteObject, hIcon2

      INVOKE     ImageList_GetIcon, hImageAssoc, 0, ILD_NORMAL
         mov     hIcon1, eax
      INVOKE     ImageList_GetIcon, hImageAssoc, 1, ILD_NORMAL
         mov     hIcon2, eax
      .if sw1 != 9
         INVOKE     SendMessage, hButtE, BM_SETIMAGE, IMAGE_ICON, hIcon1
      .endif
      INVOKE     SendMessage, hButtI, BM_SETIMAGE, IMAGE_ICON, hIcon2
      INVOKE     DeleteObject, hIcon1
      INVOKE     DeleteObject, hIcon2
         jmp     DlgDone


      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
            mov     ebx, eax
            and     eax, 0ffffh
            shr     ebx, 16
;DSPValue hWnd, eax, 1, 't'

         .if ebx == LBN_SELCHANGE
            .if eax == 15                                     ; Combobox
               INVOKE     SendMessage, hCombo, CB_GETCURSEL, 0, 0
            .else                                             ; Listbox
               INVOKE     SendMessage, hList, LB_GETCURSEL, 0, 0
            .endif
               mov     SavRet, eax
            INVOKE     SendMessage, hList, LB_GETTEXT, SavRet, addr szBuff
            INVOKE     SendMessage, hCombo, CB_GETLBTEXT, SavRet, addr szRegExt
               mov     sw1, 8  
               jmp     BuildPath

         .elseif eax == 11                     ; File association browse (Open command)
               mov     sw1, 7
               jmp     OpenFileB

         .elseif eax == 12                     ; Icon browse             (Default icon)
               mov     sw1, 9
               jmp     OpenFileB

         .elseif eax == 45                     ; Icon button
               mov     Butt45On, 1
            INVOKE     GetDlgItem, hdlg, 804
            INVOKE     SetFocus, eax 
            INVOKE     GetDlgItemText, hdlg, 804, addr szNum, sizeof szNum
            INVOKE     GetDlgItemText, hdlg, 805, addr szIconPath, sizeof szIconPath
               mov     sw1, 9
               jmp     DspIcon

         .elseif eax == IDOK
            INVOKE     GetDlgItemText, hdlg, 800, addr szRegExt, sizeof szRegExt  ; Get extension
               jmp     Update
         .elseif eax == IDCANCEL
               jmp     CancelIt
         .endif
      .endif
         jmp     DlgDone

OpenFileB:
      INVOKE     lstrcpy, addr szBuff, addr szIconPath
      INVOKE     SetCurrentDirectory, addr szBuff
      INVOKE     RtlZeroMemory, addr ofn, sizeof ofn
         mov     ofn.lStructSize, sizeof ofn
       MOVmd     ofn.hwndOwner, hWnd
       MOVmd     ofn.hInstance, hInst
         mov     ofn.lpstrFilter, offset szAssoc
         lea     eax, szBuff
         mov     ofn.lpstrFile, eax
         mov     ofn.nMaxFile, lengthof szBuff
         mov     ofn.lpstrFileTitle, offset szFileNameA
         mov     ofn.nMaxFileTitle, lengthof szFileNameA
         mov     ofn.lpstrInitialDir, 0
         mov     ofn.lpstrTitle, 0
         mov     ofn.Flags, OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST
         mov     ofn.lpstrDefExt, 0
      INVOKE     GetOpenFileName, addr ofn
         cmp     eax, FALSE       ; Cancel'ed or error occurred
          je     DlgDone
      .if sw1 == 9                ; From the icon button
         INVOKE     SetDlgItemText, hdlg, 805, addr szBuff
         INVOKE     lstrcpy, addr szIconPath, addr szBuff
            jmp     DspIcon
      .endif
      INVOKE     lstrcpy, addr szRegSave, addr szBuff
      INVOKE     lstrcpy, addr szRegPath, addr szBuff
   INVOKE     lstrcat, addr szBuff, addr szPercent1
      INVOKE     SetDlgItemText, hdlg, 801, addr szBuff
         jmp     DspIcon

Update:
         cmp     szRegExt, 0
          je     DlgDone 
      .if sw1 != 7 && sw1 != 8 && sw1 != 9
            jmp     DlgDone
      .endif
      .if DelKey == 0
            jmp     AddChange
      .endif
jmp     DlgDone

;---------- [Delete the keys for the extension]-------------
      INVOKE     RegDeleteKey, HKEY_CLASSES_ROOT, addr szRegExt ; Delete extension key

      INVOKE     lstrcpy, addr szRegValue, addr szRegExt+1
      INVOKE     lstrcat, addr szRegValue, addr szUFile
      INVOKE     lstrcpy, addr szRegSave, addr szRegValue
      INVOKE     lstrcat, addr szRegValue, addr szRegSOC
      INVOKE     RegDeleteKey, HKEY_CLASSES_ROOT, addr szRegValue ; Delete command key

      INVOKE     lstrcpy, addr szRegValue, addr szRegSave
      INVOKE     lstrcat, addr szRegValue, addr szRegShell
      INVOKE     lstrcat, addr szRegValue, addr szRegOpen
      INVOKE     RegDeleteKey, HKEY_CLASSES_ROOT, addr szRegValue ; Delete open key

      INVOKE     lstrcpy, addr szRegValue, addr szRegSave
      INVOKE     lstrcat, addr szRegValue, addr szRegShell
      INVOKE     RegDeleteKey, HKEY_CLASSES_ROOT, addr szRegValue ; Delete shell key

      INVOKE     lstrcpy, addr szRegValue, addr szRegSave
      INVOKE     lstrcat, addr szRegValue, addr szRegIcon
      INVOKE     RegDeleteKey, HKEY_CLASSES_ROOT, addr szRegValue ; Delete default icon key

      INVOKE     lstrcpy, addr szRegValue, addr szRegSave
      INVOKE     RegDeleteKey, HKEY_CLASSES_ROOT, addr szRegValue ; Delete file key
         and     sw1, 0
         and     DelKey, 0
         jmp     ReSet

         jmp     DlgDone

AddChange:
         mov     lpcbData, 256
      INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, addr szRegExt, addr szRegValue, addr lpcbData
      .if eax
;---------- [Set the extentsion, .xxx
         INVOKE     RegCreateKeyEx, HKEY_CLASSES_ROOT, addr szRegExt, 0, addr szREGSZ, 0,\
                    KEY_WRITE or KEY_READ, 0, addr hReg, addr lpdwDisp
         INVOKE     lstrcpy, addr szRegValue, addr szRegExt+1
         INVOKE     lstrcat, addr szRegValue, addr szUFile  ; szRegValue = xxx_file
         INVOKE     lstrlen, addr szRegValue
            inc     eax
         INVOKE     RegSetValueEx, hReg, 0, 0, REG_SZ, addr szRegValue, eax
         INVOKE     RegCloseKey, hReg

;---------- [Set the extentsion pointer, xxx_file
         INVOKE     RegCreateKeyEx, HKEY_CLASSES_ROOT, addr szRegValue, 0, addr szREGSZ, 0,\
                    KEY_WRITE or KEY_READ, 0, addr hReg, addr lpdwDisp
         INVOKE     lstrcpy, addr szRegSave, addr szRegExt+1
         INVOKE     lstrcat, addr szRegSave, addr szBFile  ; szRegSave = xxx file
         INVOKE     lstrlen, addr szRegSave
            inc     eax
         INVOKE     RegSetValueEx, hReg, 0, 0, REG_SZ, addr szRegSave, eax
         INVOKE     RegCloseKey, hReg
      .endif

;---------- [Set the \DefaultIcon, E:\xxxx\xxxx.exe,0
      INVOKE     lstrcpy, addr szRegSave, addr szRegValue
      INVOKE     lstrcat, addr szRegSave, addr szRegIcon
      INVOKE     RegCreateKeyEx, HKEY_CLASSES_ROOT, addr szRegSave, 0, addr szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hReg, addr lpdwDisp
      INVOKE     lstrcpy, addr szRegSave, addr szRegPath
      INVOKE     lstrcat, addr szRegSave, addr szZero
      INVOKE     GetDlgItemText, hdlg, 804, addr szNum, sizeof szNum
      INVOKE     GetDlgItemText, hdlg, 805, addr szIconPath, sizeof szIconPath
      INVOKE     lstrcpy, addr szIconTemp, addr szIconPath
      INVOKE     lstrcat, addr szIconTemp, addr szComma
      INVOKE     lstrcat, addr szIconTemp, addr szNum
      INVOKE     lstrlen, addr szIconTemp
         inc     eax
      INVOKE     RegSetValueEx, hReg, 0, 0, REG_SZ, addr szIconTemp, eax
      INVOKE     RegCloseKey, hReg

;---------- [Set the \shell\open\command, E:\xxxx\xxxx.exe %1
      INVOKE     lstrcat, addr szRegValue, addr szRegSOC
      INVOKE     RegCreateKeyEx, HKEY_CLASSES_ROOT, addr szRegValue, 0, addr szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hReg, addr lpdwDisp
      INVOKE     GetDlgItemText, hdlg, 801, addr szBuff, sizeof szBuff
      INVOKE     lstrlen, addr szBuff
         inc     eax
      INVOKE     RegSetValueEx, hReg, 0, 0, REG_SZ, addr szBuff, eax
      INVOKE     RegCloseKey, hReg

ReSet:
;---------- [Update the file ond refresh the list and combo boxes
      INVOKE     SendMessage, hList, LB_RESETCONTENT, 0, 0
      INVOKE     SendMessage, hCombo, CB_RESETCONTENT, 0, 0
         mov     sw1, 8

; Get image ID num
      INVOKE     SHGetFileInfo, addr szRegPath, 0, addr sfi, sizeof SHFILEINFO,\
                 SHGFI_SYSICONINDEX or SHGFI_SMALLICON ;or SHGFI_ICON
        test     eax, eax
          jz     ReLoad    ; Do error routine
         mov     hImageList, eax
         mov     Hand.hImageList, eax
      INVOKE     ImageList_GetIcon, hImageAssoc, 1, ILD_NORMAL
         mov     hIcon2, eax
      INVOKE     ImageList_ReplaceIcon, hImageList, SavIconID, hIcon2
      INVOKE     DeleteObject, hIcon2
      INVOKE     SendMessage, hWndListL, CM_SETHANDLES, 0, addr Hand
        call     GetImageID
        call     Refresh
      INVOKE     DeleteObject, hIcon2
         and     Butt45On, 0
         jmp     ReLoad

NoSelect:
      INVOKE     MessageBox, NULL, addr szNoFileSel, addr AppName, MB_OK or MB_ICONWARNING or MB_TASKMODAL

CancelIt:
;      INVOKE     DeleteObject, SavIcon
      INVOKE     DestroyIcon, SavIcon
      INVOKE     ImageList_Destroy, hImageAssoc
      INVOKE     EndDialog, hdlg, wParam
         mov     eax, TRUE
         jmp     DlgRet

DlgDone:
         mov     eax, FALSE
DlgRet:
         ret

AssociationDlg ENDP

;===================================================
; Change disk volume name Procedure
;===================================================
VolumeDlg PROC hdlg:DWORD, wMsg, wParam, lParam
LOCAL    szVolName[64]:BYTE, szVol[32]:BYTE, szDriveL[4]:BYTE
LOCAL    dw1:DWORD, dw2

      .if wMsg == WM_INITDIALOG
         .if !ActiveList
            INVOKE     lstrcpy, addr szRootPath, addr szListPathL
            INVOKE     lstrcpyn, addr szDrv, addr szListPathL, 4
            INVOKE     lstrcpyn, addr szDriveL, addr szListPathL, 2
         .else
            INVOKE     lstrcpy, addr szRootPath, addr szListPathR
            INVOKE     lstrcpyn, addr szDrv, addr szListPathR, 4
            INVOKE     lstrcpyn, addr szDriveL, addr szListPathR, 2
         .endif
         .if byte ptr szDrv+1 != ':'
               jmp     CancelIt
         .endif
         INVOKE     GetVolumeInformation, addr szDrv, addr szVol, 20, 0, addr dw1, addr dw2, 0, 0
         INVOKE     lstrcpy, addr szVolName, addr szDriveD
         INVOKE     lstrcat, addr szVolName, addr szSpace
         INVOKE     lstrcat, addr szVolName, addr szBL
         INVOKE     lstrcat, addr szVolName, addr szDriveL
         INVOKE     lstrcat, addr szVolName, addr szBR
         INVOKE     lstrcat, addr szVolName, addr szSpace2
         INVOKE     lstrcat, addr szVolName, addr szVolD
         INVOKE     lstrcat, addr szVolName, addr szSpace
         INVOKE     lstrcat, addr szVolName, addr szBL
         INVOKE     lstrcat, addr szVolName, addr szVol
         INVOKE     lstrcat, addr szVolName, addr szBR

         INVOKE     SetDlgItemText, hdlg, 801, addr szVolName
         INVOKE     SetDlgItemText, hdlg, 802, addr szVol
         INVOKE     GetDlgItem, hdlg, 802
         INVOKE     SetFocus, eax
            jmp     DlgDone

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
            and     eax, 0ffffh

         .if eax == IDCANCEL
               jmp     CancelIt

         .elseif eax == IDOK
            INVOKE     GetDlgItemText, hdlg, 802, addr szVolName, sizeof szVolName
            INVOKE     lstrlen, addr szVolName
            .if eax > 31
               INVOKE     MessageBox, NULL, addr szTooLong, addr AppName, MB_OK or MB_ICONWARNING or MB_TASKMODAL
                  jmp     DlgDone
            .endif
            INVOKE     SetVolumeLabel, addr szDrv, addr szVolName
              call     GetHeader
               jmp     CancelIt
         .endif
      .elseif wMsg == WM_CLOSE
            jmp     CancelIt
      .endif
         jmp     DlgDone

CancelIt:
      INVOKE     EndDialog, hdlg, wParam
         mov     eax, TRUE
         jmp     DlgRet

DlgDone:
         mov     eax, FALSE

DlgRet:
         ret
VolumeDlg ENDP

;===================================================
; Pack Unpack selected files Procedure
;===================================================
PackUnpack PROC uses ebx esi wMsg:DWORD, wParam, lParam
LOCAL    stin:STARTUPINFO
LOCAL    prin:PROCESS_INFORMATION
LOCAL    SelCnt:DWORD, Cnt, Val
LOCAL    szBuff[4048*2]:BYTE, szZFileName[256]:BYTE, szWork01[256]:BYTE


      INVOKE     RtlZeroMemory, addr stin, sizeof STARTUPINFO

;INVOKE     lstrcpy, addr szPgmZip, addr szPgmZip ;TestZip
;mov     ChkZip, 1
      .if !ChkZip
            cmp     szZipPack, 0
             je     ZipError
      .else
            cmp     szPgmZip, 0
             je     ZipError
      .endif

         mov     esi, ActiveList
      INVOKE     SendMessage, hWndListL[esi*4], CM_CHECKSELECT, 0, addr SelArray
      .if !eax
         INVOKE     MessageBox, NULL, addr szNoSelect, addr AppName, MB_OK or MB_ICONWARNING or MB_TASKMODAL
            jmp     Ret0
      .endif
         mov     SelCnt, eax

      .if !ActiveList
         INVOKE     lstrcpy, addr szRootPath, addr szListPathL
      .else
         INVOKE     lstrcpy, addr szRootPath, addr szListPathR
      .endif
      INVOKE     SetCurrentDirectory, addr szRootPath

      .if !ChkZip
         INVOKE     lstrcpy, addr szBuff, addr szZipPack
            jmp     NoPgmZip
      .endif

;---------- [Create a memory block to write selected files to
      INVOKE     HeapCreate, HEAP_GENERATE_EXCEPTIONS, 20000, 0
         mov     hMemHeap, eax
      INVOKE     HeapAlloc, hMemHeap, HEAP_GENERATE_EXCEPTIONS, 20000
         mov     hHeapAlloc, eax

         mov     eax, hHeapAlloc
         mov     byte ptr[eax], 0
         mov     esi, ActiveList
         and     Cnt, 0
      .while (SelCnt)
            mov     eax, Cnt
            mov     ebx, SelArray[eax*4]
            shl     ebx, 16
         INVOKE     SendMessage, hWndListL[esi*4], CM_GETCELLDATA, ebx, addr szWork01
         INVOKE     lstrcpy, addr szZFileName, addr szQuote
         INVOKE     lstrcat, addr szZFileName, addr szWork01
         INVOKE     lstrcat, addr szZFileName, addr szQuote

            mov     bx, 5
         INVOKE     SendMessage, hWndListL[esi*4], CM_GETCELLDATA, ebx, addr Val
         .if Val == 1                                        ; 1 = GoBack
               jmp     Pass
         .endif
         INVOKE     lstrcat, hHeapAlloc, addr szZFileName
         .if Val == 2                                        ; 2 = Folder
            INVOKE     lstrcat, hHeapAlloc, addr szFolderP   ; = \* To extract from folders
         .endif
         INVOKE     lstrcat, hHeapAlloc, addr szSpace

Pass:
            inc     Cnt
            dec     SelCnt
      .endw

      INVOKE     BaseAscii, Cnt, addr CopyNum, 4, 10, 1, 0, 1
      INVOKE     lstrcpy, addr szWork, addr szPackD
      INVOKE     lstrcpy, addr szListFrom, addr CopyFiles
      INVOKE     lstrcat, addr szListFrom, addr CopyNum
      INVOKE     lstrcat, addr szListFrom, addr Files
      INVOKE     lstrcat, addr szListFrom, addr szArchive
      INVOKE     lstrcpy, addr szBuff, addr szRootPath
         mov     Funct, 5040
      INVOKE     DialogBoxParam, hInst, IDD_CONFIRM, hWnd, offset ConfirmDlg, 0
      .if eax == IDCANCEL
            jmp     FreeMem
      .endif
      INVOKE     LoadCursor, 0, IDC_WAIT
      INVOKE     SetCursor, eax

      INVOKE     lstrcpy, addr szRootPath, addr szBuff

;---------- [Build the command line for 7Zip Pack
; Example J:\Utilities\PackUnPack\7Zip.exe a K:\TempExtr abcd.txt Folder01\* efgh.asm 123.doc -r
      INVOKE     lstrcat, hHeapAlloc, addr szr
      INVOKE     lstrcpy, addr szBuff, addr szPgmZip      ; Zip program
      INVOKE     lstrcat, addr szBuff, addr sza           ; Command
      INVOKE     lstrcat, addr szBuff, addr szWork        ; Archive name
      INVOKE     lstrcat, addr szBuff, addr szSpace
      INVOKE     lstrcat, addr szBuff, hHeapAlloc         ; Input file/folder names & sw
         jmp     CreateP

NoPgmZip:
      INVOKE     CreateProcess, 0, addr szBuff, 0, 0, FALSE,\
                 NORMAL_PRIORITY_CLASS, 0, 0 , addr stin, addr prin
      INVOKE     CloseHandle, prin.hProcess
      INVOKE     CloseHandle, prin.hThread
         jmp     Ret0

CreateP:
      INVOKE     GetStartupInfo, addr stin
         mov     stin.cb, SIZEOF stin
         mov     stin.dwFlags, STARTF_USESHOWWINDOW
         mov     stin.wShowWindow, SW_HIDE
      INVOKE     CreateProcess, 0, addr szBuff, 0, 0, FALSE,\
                 NORMAL_PRIORITY_CLASS, 0, 0 , addr stin, addr prin
      INVOKE     CloseHandle, prin.hProcess
      INVOKE     CloseHandle, prin.hThread

FreeMem:
      .if wParam == IDM_PACK
         INVOKE     HeapDestroy, hMemHeap
      .endif

LVR:
      INVOKE     lstrcat, addr szWork, addr szZip
         mov     eax, -1
         and     Cnt, 0
      .while (Cnt < 75000 && eax == -1)
         INVOKE     GetFileAttributes, addr szWork
            inc     Cnt
      .endw
        call     Refresh
         jmp     Ret0

NoZip:
      INVOKE     MessageBox, NULL, addr szNoZip, addr AppName, MB_OK or MB_ICONWARNING
         jmp     Ret0

ZipError:
      INVOKE     MessageBox, NULL, addr szZipError, addr AppName, MB_OK or MB_ICONWARNING
         jmp     Ret0

Ret0:
      INVOKE     LoadCursor, 0, IDC_ARROW
      INVOKE     SetCursor, eax
         and     Funct, 0
         ret

PackUnpack ENDP

;===================================================
; Expand the directory or directories for file size Procedure
;===================================================
Explode PROC uses ebx esi edi
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    hFind:DWORD, ListTot, Cnt, Val
LOCAL    szBuff0[256]:BYTE, szBuff1[256]:BYTE, szBuff2[256]:BYTE, szBuff3[256]:BYTE

         and     Cnt, 0

GetDir:
         and     ListTot, 0
      .if !ActiveList
         INVOKE     lstrcpy, addr szBuff0, addr szListPathL
      .else
         INVOKE     lstrcpy, addr szBuff0, addr szListPathR
      .endif

         mov     esi, ActiveList
         mov     eax, Cnt
         mov     ebx, SelArray[eax*4]
         shl     ebx, 16
      INVOKE     SendMessage, hWndListL[esi*4], CM_GETCELLDATA, ebx, addr szFileName
         mov     bx, 5
      INVOKE     SendMessage, hWndListL[esi*4], CM_GETCELLDATA, ebx, addr Val
      .if Val != 2 && Val != 9                                        ; 2 or 9 = Folder
            jmp     Pass
      .endif
      INVOKE     lstrcat, addr szBuff0, addr szFileName
      INVOKE     lstrcat, addr szBuff0, addr szAll

      INVOKE     FindFirstFile, addr szBuff0, addr FindData
        test     eax, eax
          js     NoFile
         mov     hFind, eax
         jmp     ChkDir

;_______________________________________________________________________
NextDir:
      INVOKE     FindNextFile, hFind, addr FindData
        test     eax, eax
          jz     AllDone

;_______________________________________________________________________
ChkDir:
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)

;_______________________________________________________________________
DoMore1:
         .if byte ptr FindData.cFileName == '.'
               jmp     NextDir
         .endif

         INVOKE     lstrlen, addr szBuff0
            sub     eax, 2
         INVOKE     lstrcpyn, addr szBuff1, addr szBuff0, eax
         INVOKE     lstrcat, addr szBuff1, addr FindData.cFileName
         INVOKE     lstrcat, addr szBuff1, addr szAll
            mov     Lev, 0
            jmp     GetSubDir

      .else
            mov     eax, MAXDWORD
           imul     eax, FindData.nFileSizeHigh
            add     eax, FindData.nFileSizeLow
            add     ListTot, eax
      .endif



         jmp     NextDir

;_______________________________________________________________________
GetSubDir:
      INVOKE     FindFirstFile, addr szBuff1, addr FindData
      .if eax == -1
         .if !Lev
               jmp     NextDir
         .else
               mov     ebx, Lev
               mov     eax, PathLen[ebx*4]
            INVOKE     lstrcpyn, addr szBuff1, addr szBuff1, eax
               dec     Lev
               jmp     GetSubDir
         .endif
      .endif
         mov     ebx, Lev
         mov     hSubDir[ebx*4], eax
         jmp     ChkSubDir

;_______________________________________________________________________
NextSubDir:
         mov     ebx, Lev
      INVOKE     FindNextFile, hSubDir[ebx*4], addr FindData
      .if !eax  ;eax = 0 = failure
            mov     ebx, Lev   
         INVOKE     FindClose, hSubDir[ebx*4]
         .if !Lev
               jmp     NextDir
         .else
               dec     Lev
               mov     ebx, Lev
               mov     eax, PathLen[ebx*4]
               sub     eax, 3
            INVOKE     lstrcpyn, addr szBuff1, addr szBuff1, eax
            INVOKE     lstrcat, addr szBuff1, addr szAll
               jmp     NextSubDir
         .endif
      .endif

;_______________________________________________________________________
ChkSubDir:
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)

;_______________________________________________________________________
DoMore2:
         .if byte ptr FindData.cFileName == '.'
               jmp     NextSubDir
         .endif
         INVOKE     lstrlen, addr szBuff1
            mov     ebx, Lev
            mov     PathLen[ebx*4], eax
            sub     eax, 2
         INVOKE     lstrcpyn, addr szBuff1, addr szBuff1, eax
         INVOKE     lstrcat, addr szBuff1, addr FindData.cFileName
         INVOKE     lstrcat, addr szBuff1, addr szAll
            inc     Lev
            jmp     GetSubDir

      .else
            mov     eax, MAXDWORD
           imul     eax, FindData.nFileSizeHigh
            add     eax, FindData.nFileSizeLow
            add     ListTot, eax
      .endif
         jmp     NextSubDir

AllDone:
      INVOKE     FindClose, hFind
         mov     esi, ActiveList
         mov     eax, Cnt
         mov     ebx, SelArray[eax*4]
         shl     ebx, 16
         mov     bx, 5
         mov     Val, 9
      INVOKE     SendMessage, hWndListL[esi*4], CM_SETCELLDATA, ebx, addr Val
         mov     bx, 2
      INVOKE     SendMessage, hWndListL[esi*4], CM_SETCELLDATA, ebx, addr ListTot

Pass:
         inc     Cnt
         dec     ListSelTot
      .if ListSelTot
            jmp     GetDir
      .endif

NoFile:

Ret0:
         ret

Explode ENDP

;===================================================
; Search output Procedure
;===================================================
SearchDlg PROC hdlg:DWORD, wMsg, wParam, lParam

      .if wMsg == WM_INITDIALOG
            mov     eax, hdlg
            mov     hTemp01, eax
         INVOKE     GetDlgItem, hdlg, 806
            mov     hEdit01, eax
         INVOKE     GetDlgItem, hdlg, 807
            mov     hEdit02, eax
         INVOKE     GetDlgItem, hdlg, 808
            mov     hEdit03, eax
         INVOKE     GetDlgItem, hdlg, 901
            mov     hStatic01, eax
         INVOKE     SendMessage, hEdit01, EM_SETLIMITTEXT, 500000, 0
         INVOKE     SendMessage, hEdit01, WM_SETFONT, hFontT, TRUE
         INVOKE     SendMessage, hEdit02, WM_SETFONT, hFontM, TRUE
         INVOKE     SendMessage, hEdit03, WM_SETFONT, hFontM, TRUE
         INVOKE     SendMessage, hStatic01, WM_SETFONT, hFontC, TRUE

      .elseif wMsg == WM_CLOSE
;         INVOKE     EndDialog, hdlg, wParam
         INVOKE     DestroyWindow, hdlg     ; End the dialog
         INVOKE     SetFocus, hWnd
            mov     eax, TRUE
            jmp     DlgRet

      .endif

DlgDone:
         mov     eax, FALSE

DlgRet:
         ret

SearchDlg ENDP

;===================================================
; Find folder, file, or string Procedure
;===================================================
FindFoldFile PROC uses ebx esi edi Code:DWORD, Var, CaseS, SelFiles
LOCAL    syst:SYSTEMTIME
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    wHr:DWORD, wMin, wSec, wMSec
LOCAL    hFind:DWORD, Cnt, WildOn, Len, Totals, STime, ETime
LOCAL    szBuff0[256]:BYTE, szBuff1[256]:BYTE, szBuff2[256]:BYTE, szBuff3[12]:BYTE

         and     Totals, 0
         mov     eax, NumDrives
         mov     Cnt, eax
      .if Var >= 'A' && Var <= 'Z'
            mov     al, byte ptr Var
            mov     szRoot, al
            mov     Cnt, 1
      .endif
         and     WildOn, 0
      INVOKE     lstrlen, addr szFoldFile
      .if byte ptr szFoldFile[eax-1] == '*'
            mov     WildOn, 1
            dec     eax
         INVOKE     lstrcpyn, addr szFoldFile, addr szFoldFile, eax
      .endif
      INVOKE     lstrlen, addr szFoldFile
         mov     Len, eax

      INVOKE     CreateDialogParam, hInst, IDD_SEARCH, hWnd, offset SearchDlg, 0

      INVOKE     LoadCursor, 0, IDC_WAIT
         mov     hCursor, eax
      INVOKE     SetCursor, eax
      INVOKE     GetTickCount
         mov     STime, eax

GetDir:
      INVOKE     GetAsyncKeyState, VK_SPACE
      .if eax
            mov     Cnt, 1
            jmp     AllDone
      .endif

      INVOKE     lstrcpy, addr szBuff0, addr szRoot
      INVOKE     lstrcat, addr szBuff0, addr szAll+1

      INVOKE     FindFirstFile, addr szBuff0, addr FindData
        test     eax, eax
          js     NoFile
         mov     hFind, eax
         jmp     ChkDir

;_______________________________________________________________________
NextDir:
      INVOKE     FindNextFile, hFind, addr FindData
        test     eax, eax
          jz     AllDone

;_______________________________________________________________________
ChkDir:
      .if byte ptr FindData.cFileName == '.'
            jmp     NextDir
      .endif
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)

;_______________________________________________________________________
DoMore1:
         INVOKE     lstrlen, addr szBuff0
            sub     eax, 2
         INVOKE     lstrcpyn, addr szBuff1, addr szBuff0, eax
         INVOKE     lstrcat, addr szBuff1, addr FindData.cFileName

         .if Code == 13  ; Folder
            INVOKE     SetWindowText, hTemp01, addr szBuff1
            .if CaseS
               INVOKE     lstrcmp, addr FindData.cFileName, addr szFoldFile
            .else
               INVOKE     lstrcmpi, addr FindData.cFileName, addr szFoldFile
            .endif
            .if !eax
                 call     WriteOutPut
            .endif
         .endif

         INVOKE     lstrcat, addr szBuff1, addr szAll
            mov     Lev, 0
            jmp     GetSubDir

      .else
         .if Code == 14  ; File
            INVOKE     SetWindowText, hTemp01, addr szBuff1
            .if WildOn
               INVOKE     lstrlen, addr FindData.cFileName
                  mov     ebx, eax
               .while (ebx)
                     dec     ebx
                  .if FindData.cFileName[ebx-1] == '.'
                     .break
                  .endif
               .endw
                  dec     ebx
               INVOKE     lstrcpy, addr szExt, addr FindData.cFileName[ebx]
                  inc     ebx
               INVOKE     lstrcpyn, addr FindData.cFileName, addr FindData.cFileName, ebx
            .endif
            .if CaseS
               INVOKE     lstrcmp, addr FindData.cFileName, addr szFoldFile
            .else
               INVOKE     lstrcmpi, addr FindData.cFileName, addr szFoldFile
            .endif
            .if !eax
               INVOKE     lstrlen, addr szBuff1
                  sub     eax, 2
               INVOKE     lstrcpyn, addr szBuff2, addr szBuff1, eax
               .if WildOn
                  INVOKE     lstrcat, addr FindData.cFileName, addr szExt
               .endif
               INVOKE     lstrcat, addr szBuff2, addr FindData.cFileName
Out1:
                 call     WriteOutPut
            .endif

         .elseif Code == 15  ; String
            .if SelFiles
                 call     ExtractExt
               .if byte ptr szExt+1 == 'a' && byte ptr szExt+2 == 's' ||\
                   byte ptr szExt+1 == 'i' && byte ptr szExt+2 == 'n' ||\
                   byte ptr szExt+1 == 'r' && byte ptr szExt+2 == 'c'
               .else
                    jmp     NextDir
               .endif
            .endif

            INVOKE     lstrlen, addr szBuff1
               sub     eax, 2
            INVOKE     lstrcpyn, addr szBuff2, addr szBuff1, eax
            INVOKE     lstrcat, addr szBuff2, addr FindData.cFileName
            INVOKE     SetWindowText, hTemp01, addr szBuff2
               mov     ecx, hBuff
            INVOKE     lstrcpy, ecx, addr szBuff2
              call     ReadF
            .if eax
                 call     DoSearch
               .if eax == -1
                     jmp     Out1
               .endif
            .endif
         .endif
      .endif
         jmp     NextDir

;_______________________________________________________________________
GetSubDir:
      INVOKE     GetAsyncKeyState, VK_SPACE
      .if eax
            mov     Cnt, 1
            jmp     AllDone
      .endif
      INVOKE     FindFirstFile, addr szBuff1, addr FindData
      .if eax == -1
         .if !Lev
               jmp     NextDir
         .else
               mov     ebx, Lev
               mov     eax, PathLen[ebx*4]
            INVOKE     lstrcpyn, addr szBuff1, addr szBuff1, eax
               dec     Lev
               jmp     GetSubDir
         .endif
      .endif
         mov     ebx, Lev
         mov     hSubDir[ebx*4], eax
         jmp     ChkSubDir

;_______________________________________________________________________
NextSubDir:
         mov     ebx, Lev
      INVOKE     FindNextFile, hSubDir[ebx*4], addr FindData
      .if !eax  ;eax = 0 = failure
            mov     ebx, Lev   
         INVOKE     FindClose, hSubDir[ebx*4]
         .if !Lev
               jmp     NextDir
         .else
               dec     Lev
               mov     ebx, Lev
               mov     eax, PathLen[ebx*4]
               sub     eax, 3
            INVOKE     lstrcpyn, addr szBuff1, addr szBuff1, eax
            INVOKE     lstrcat, addr szBuff1, addr szAll
               jmp     NextSubDir
         .endif
      .endif

;_______________________________________________________________________
ChkSubDir:
      .if byte ptr FindData.cFileName == '.'
            jmp     NextSubDir
      .endif

      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)

;_______________________________________________________________________
DoMore2:
         INVOKE     lstrlen, addr szBuff1
            mov     ebx, Lev
            mov     PathLen[ebx*4], eax
            sub     eax, 2
         INVOKE     lstrcpyn, addr szBuff1, addr szBuff1, eax
         INVOKE     lstrcat, addr szBuff1, addr FindData.cFileName

         .if Code == 13  ; Folder
            INVOKE     SetWindowText, hTemp01, addr szBuff1
            .if CaseS
               INVOKE     lstrcmp, addr FindData.cFileName, addr szFoldFile
            .else
               INVOKE     lstrcmpi, addr FindData.cFileName, addr szFoldFile
            .endif
            .if !eax
                 call     WriteOutPut
            .endif
         .endif

         INVOKE     lstrcat, addr szBuff1, addr szAll
            inc     Lev
            jmp     GetSubDir

      .else
         .if Code == 14  ; File
            INVOKE     SetWindowText, hTemp01, addr szBuff1
            .if WildOn
               INVOKE     lstrlen, addr FindData.cFileName
                  mov     ebx, eax
               .while (ebx)
                     dec     ebx
                  .if FindData.cFileName[ebx-1] == '.'
                     .break
                  .endif
               .endw
                  dec     ebx
               INVOKE     lstrcpy, addr szExt, addr FindData.cFileName[ebx]
                  inc     ebx
               INVOKE     lstrcpyn, addr FindData.cFileName, addr FindData.cFileName, ebx
            .endif
            .if CaseS
               INVOKE     lstrcmp, addr FindData.cFileName, addr szFoldFile
            .else
               INVOKE     lstrcmpi, addr FindData.cFileName, addr szFoldFile
            .endif
            .if !eax
               INVOKE     lstrlen, addr szBuff1
                  sub     eax, 2
               INVOKE     lstrcpyn, addr szBuff2, addr szBuff1, eax
               .if WildOn
                  INVOKE     lstrcat, addr FindData.cFileName, addr szExt
               .endif
               INVOKE     lstrcat, addr szBuff2, addr FindData.cFileName
Out2:
                 call     WriteOutPut
            .endif

         .elseif Code == 15  ; String
            .if SelFiles
                 call     ExtractExt
               .if byte ptr szExt+1 == 'a' && byte ptr szExt+2 == 's' ||\
                   byte ptr szExt+1 == 'i' && byte ptr szExt+2 == 'n' ||\
                   byte ptr szExt+1 == 'r' && byte ptr szExt+2 == 'c'
               .else
                    jmp     NextSubDir
               .endif
            .endif

            INVOKE     lstrlen, addr szBuff1
               sub     eax, 2
            INVOKE     lstrcpyn, addr szBuff2, addr szBuff1, eax
            INVOKE     lstrcat, addr szBuff2, addr FindData.cFileName
            INVOKE     SetWindowText, hTemp01, addr szBuff2
               mov     ecx, hBuff
            INVOKE     lstrcpy, ecx, addr szBuff2
              call     ReadF
            .if eax
                 call     DoSearch
               .if eax == -1
                     jmp     Out2
               .endif
            .endif
         .endif
      .endif
         jmp     NextSubDir

AllDone:
      INVOKE     FindClose, hFind
         dec     Cnt
      .if Cnt
            add     szRoot, 1
            jmp     GetDir
      .endif

NoFile:

Ret0:
        call     DoTime
      .if hpMem
         INVOKE     GlobalUnlock, fpMem
         INVOKE     GlobalFree, hpMem
            mov     hpMem, 0
      .endif
         mov     byte ptr szRoot, 'C'
      INVOKE     LoadCursor, 0, IDC_ARROW
      INVOKE     SetCursor, eax
         mov     hCursor, 0
         ret

DoTime:
      INVOKE     GetTickCount
         sub     eax, STime
         xor     edx, edx
         mov     ecx, 360000
         div     ecx
         mov     wHr, eax
         mov     eax, edx
         xor     edx, edx
         mov     ecx, 60000
         div     ecx
         mov     wMin, eax
         mov     eax, edx
         xor     edx, edx
         mov     ecx, 1000
         div     ecx
         mov     wSec, eax
         mov     wMSec, edx
      INVOKE     BaseAscii, wHr, addr szTimePict, 2, 10, 0, 1, 0
      INVOKE     BaseAscii, wMin, addr szTimePict+3, 2, 10, 0, 1, 0
      INVOKE     BaseAscii, wSec, addr szTimePict+6, 2, 10, 0, 1, 0
      INVOKE     BaseAscii, wMSec, addr szTimePict+9, 3, 10, 0, 1, 0
      INVOKE     SendMessage, hEdit03, EM_SETSEL, 0, -1
      INVOKE     SendMessage, hEdit03, EM_REPLACESEL, FALSE, addr szTimePict
        retn

WriteOutPut:
        call     DoTime
         inc     Totals
      INVOKE     BaseAscii, Totals, addr szBuff3, 1, 10, 1, 1, 1
      INVOKE     SendMessage, hEdit02, EM_SETSEL, 0, -1
      INVOKE     SendMessage, hEdit02, EM_REPLACESEL, FALSE, addr szBuff3
      INVOKE     SendMessage, hEdit01, EM_SETSEL, -1, 0
      .if Code == 13
         INVOKE     SendMessage, hEdit01, EM_REPLACESEL, FALSE, addr szBuff1
      .else
         INVOKE     SendMessage, hEdit01, EM_REPLACESEL, FALSE, addr szBuff2
      .endif
      INVOKE     SendMessage, hEdit01, EM_SETSEL, -1, 0
      INVOKE     SendMessage, hEdit01, EM_REPLACESEL, FALSE, addr szCRLF
        retn

ExtractExt:
      INVOKE     lstrlen, addr FindData.cFileName
      .while (eax)
            dec     eax
         .if FindData.cFileName[eax-1] == '.'
            .break
         .endif
      .endw
         dec     eax
      INVOKE     lstrcpy, addr szExt, addr FindData.cFileName[eax]
      .if byte ptr szExt+1 >= 'A' && byte ptr szExt+1 <= 'Z'
            add     byte ptr szExt+1, 20h
      .endif
      .if byte ptr szExt+2 >= 'A' && byte ptr szExt+2 <= 'Z'
            add     byte ptr szExt+2, 20h
      .endif
         retn

DoSearch:
         mov     ebx, 'ssuP'
         mov     esi, fpMem
         xor     eax, eax
      .while (BytesR)
;         .if dword ptr [esi+eax] == ebx
;               mov     eax, -1
;            .break
;         .endif

            xor     edi, edi
            mov     ebx, eax
            mov     ecx, Len
         .while (ecx)
               mov     dl, byte ptr [esi+ebx]
            .if dl != byte ptr szFoldFile[edi]
               .break
            .endif
               inc     ebx
               inc     edi
               dec     ecx
         .endw
         .if !ecx
               mov     eax, -1
            .break
         .endif

            inc     eax
            dec     BytesR
      .endw
        retn

FindFoldFile ENDP

;===================================================
; Read file  PROCEDURE
;===================================================
ReadF PROC  uses ebx
LOCAL    hFile:DWORD

      .if hpMem
         INVOKE     GlobalUnlock, fpMem
         INVOKE     GlobalFree, hpMem
            mov     hpMem, 0
      .endif

         mov     ebx, hBuff
      INVOKE     CreateFile, ebx, GENERIC_READ, FILE_SHARE_READ,\
                 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
      .if eax == INVALID_HANDLE_VALUE
            xor     eax, eax
            jmp     NoFile
      .endif
         mov     hFile, eax
      INVOKE     GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, 8000000
         mov     hpMem, eax
      INVOKE     GlobalLock, hpMem
         mov     fpMem, eax
      INVOKE     ReadFile, hFile, fpMem, 8000000, addr BytesR, NULL
        push     eax
      INVOKE     CloseHandle, hFile
         pop     eax

NoFile:
         ret

ReadF ENDP
